//
//	Software Platform Generated File
//	--------------------------------
//

#ifndef _GRAPHICS_CFG_INSTANCE_H
#define _GRAPHICS_CFG_INSTANCE_H

#include <stdint.h>
#include <stdbool.h>
#include <stdlib.h>
#include <stddef.h>

#include "graphics_cfg.h"
#include "ad_vga_ili9320_cfg_instance.h"
#include "graphics.h"


#define GRAPHICS_COLOR_FORMAT_COLOR_RGB565			COLOR_RGB565
#define GRAPHICS_COLOR_FORMAT_COLOR_PALETTE8			COLOR_PALETTE8
#define GRAPHICS_COLOR_FORMAT_COLOR_PALETTE4			COLOR_PALETTE4
#define GRAPHICS_COLOR_FORMAT_COLOR_PALETTE2			COLOR_PALETTE2
#define GRAPHICS_COLOR_FORMAT_COLOR_PALETTE1			COLOR_PALETTE1

#define GRAPHICS_ROTATION_0			0
#define GRAPHICS_ROTATION_90			90
#define GRAPHICS_ROTATION_180			180
#define GRAPHICS_ROTATION_270			270

#define GRAPHICS_DEFAULT_FONT_BITSTREAM_VERA_SANS_8			&bitstreamverasans8
#define GRAPHICS_DEFAULT_FONT_BITSTREAM_VERA_SANS_10			&bitstreamverasans10
#define GRAPHICS_DEFAULT_FONT_BITSTREAM_VERA_SANS_MONO_8			&bitstreamverasansmono8
#define GRAPHICS_DEFAULT_FONT_BITSTREAM_VERA_SANS_MONO_10			&bitstreamverasansmono10
#define GRAPHICS_DEFAULT_FONT_BITSTREAM_VERA_SERIF_8			&bitstreamveraserif8
#define GRAPHICS_DEFAULT_FONT_BITSTREAM_VERA_SERIF_10			&bitstreamveraserif10
#define GRAPHICS_DEFAULT_FONT_BPMONO_8			&bpmono8
#define GRAPHICS_DEFAULT_FONT_BPMONO_10			&bpmono10
#define GRAPHICS_DEFAULT_FONT_USER_SUPPLIED			((void*)-1)
#define GRAPHICS_DEFAULT_FONT_NO_DEFAULT_FONT			NULL

#define GRAPHICS_CANVASCOUNT_0			0
#define GRAPHICS_CANVASCOUNT_1			1
#define GRAPHICS_CANVASCOUNT_2			2
#define GRAPHICS_CANVASCOUNT_3			3
#define GRAPHICS_CANVASCOUNT_4			4

#define GRAPHICS_INSTANCE_CANVAS_WIDTH_MAX			320
#define GRAPHICS_INSTANCE_CANVAS_WIDTH_MIN			320

#define GRAPHICS_INSTANCE_CANVAS_HEIGHT_MAX			240
#define GRAPHICS_INSTANCE_CANVAS_HEIGHT_MIN			240

#define GRAPHICS_INSTANCE_COLOR_FORMAT_COLOR_RGB565_USED			1
#define GRAPHICS_INSTANCE_COLOR_FORMAT_COLOR_PALETTE8_USED			0
#define GRAPHICS_INSTANCE_COLOR_FORMAT_COLOR_PALETTE4_USED			0
#define GRAPHICS_INSTANCE_COLOR_FORMAT_COLOR_PALETTE2_USED			0
#define GRAPHICS_INSTANCE_COLOR_FORMAT_COLOR_PALETTE1_USED			0
#define GRAPHICS_INSTANCE_COLOR_FORMAT_OPTIONS_USED			1
#define GRAPHICS_INSTANCE_COLOR_FORMAT_MIN			GRAPHICS_INSTANCE_COLOR_FORMAT_COLOR_RGB565
#define GRAPHICS_INSTANCE_COLOR_FORMAT_MAX			GRAPHICS_INSTANCE_COLOR_FORMAT_COLOR_RGB565

#define GRAPHICS_INSTANCE_ROTATION_0_USED			1
#define GRAPHICS_INSTANCE_ROTATION_90_USED			0
#define GRAPHICS_INSTANCE_ROTATION_180_USED			0
#define GRAPHICS_INSTANCE_ROTATION_270_USED			0
#define GRAPHICS_INSTANCE_ROTATION_OPTIONS_USED			1
#define GRAPHICS_INSTANCE_ROTATION_MIN			GRAPHICS_INSTANCE_ROTATION_0
#define GRAPHICS_INSTANCE_ROTATION_MAX			GRAPHICS_INSTANCE_ROTATION_0

#define GRAPHICS_INSTANCE_DEFAULT_FONT_BITSTREAM_VERA_SANS_8_USED			0
#define GRAPHICS_INSTANCE_DEFAULT_FONT_BITSTREAM_VERA_SANS_10_USED			0
#define GRAPHICS_INSTANCE_DEFAULT_FONT_BITSTREAM_VERA_SANS_MONO_8_USED			0
#define GRAPHICS_INSTANCE_DEFAULT_FONT_BITSTREAM_VERA_SANS_MONO_10_USED			0
#define GRAPHICS_INSTANCE_DEFAULT_FONT_BITSTREAM_VERA_SERIF_8_USED			0
#define GRAPHICS_INSTANCE_DEFAULT_FONT_BITSTREAM_VERA_SERIF_10_USED			0
#define GRAPHICS_INSTANCE_DEFAULT_FONT_BPMONO_8_USED			1
#define GRAPHICS_INSTANCE_DEFAULT_FONT_BPMONO_10_USED			0
#define GRAPHICS_INSTANCE_DEFAULT_FONT_USER_SUPPLIED_USED			0
#define GRAPHICS_INSTANCE_DEFAULT_FONT_NO_DEFAULT_FONT_USED			0
#define GRAPHICS_INSTANCE_DEFAULT_FONT_OPTIONS_USED			1
#define GRAPHICS_INSTANCE_DEFAULT_FONT_MIN			GRAPHICS_INSTANCE_DEFAULT_FONT_BPMONO_8
#define GRAPHICS_INSTANCE_DEFAULT_FONT_MAX			GRAPHICS_INSTANCE_DEFAULT_FONT_BPMONO_8

#define GRAPHICS_INSTANCE_CANVASCOUNT_0_USED			0
#define GRAPHICS_INSTANCE_CANVASCOUNT_1_USED			1
#define GRAPHICS_INSTANCE_CANVASCOUNT_2_USED			0
#define GRAPHICS_INSTANCE_CANVASCOUNT_3_USED			0
#define GRAPHICS_INSTANCE_CANVASCOUNT_4_USED			0
#define GRAPHICS_INSTANCE_CANVASCOUNT_OPTIONS_USED			1
#define GRAPHICS_INSTANCE_CANVASCOUNT_MIN			GRAPHICS_INSTANCE_CANVASCOUNT_1
#define GRAPHICS_INSTANCE_CANVASCOUNT_MAX			GRAPHICS_INSTANCE_CANVASCOUNT_1

#define GRAPHICS_INSTANCE_CANVASBUFFER1_MAX			153600
#define GRAPHICS_INSTANCE_CANVASBUFFER1_MIN			153600

#define GRAPHICS_INSTANCE_CANVASBUFFER2_MAX			153600
#define GRAPHICS_INSTANCE_CANVASBUFFER2_MIN			153600

#define GRAPHICS_INSTANCE_CANVASBUFFER3_MAX			153600
#define GRAPHICS_INSTANCE_CANVASBUFFER3_MIN			153600

#define GRAPHICS_INSTANCE_CANVASBUFFER4_MAX			153600
#define GRAPHICS_INSTANCE_CANVASBUFFER4_MIN			153600

typedef struct
{
	uint32_t   			canvas_width;
	uint32_t   			canvas_height;
	int32_t    			color_format;
	int32_t    			rotation;
	const font_t*			default_font;
	const font_t			*user_supplied;
	int32_t    			canvascount;
	uint8_t    			*canvasbuffer1;
	size_t     			canvasbuffer1_size;
	bool       			canvasbuffer1_double;
	uint8_t    			*canvasbuffer2;
	size_t     			canvasbuffer2_size;
	bool       			canvasbuffer2_double;
	uint8_t    			*canvasbuffer3;
	size_t     			canvasbuffer3_size;
	bool       			canvasbuffer3_double;
	uint8_t    			*canvasbuffer4;
	size_t     			canvasbuffer4_size;
	bool       			canvasbuffer4_double;
	int*       			ad_graphics;
	int        			ad_graphics_size;
} graphics_cfg_instance_t;


extern const graphics_cfg_instance_t	graphics_instance_table[];

#endif
